#!/bin/bash

#Ersteller: Michael Spahr
#Datum der letzen Änderung: 03.07.2017
#Version: 1.0
#Dieses Programm darf jeder verändern und erweitern. Ich bitte Euch mir dann die Änderungen zu schicken, so daß ich diese in den offziellen Teil einbaun kann
#Viel Spaß beim Laden der Youtube-Filme


#Start
#Verarbeiten der Eingabeparameter und (am Programmende) Aaufruf der weiteren Funktionen
art="$1"
link="$2"
name="$3"
verzeichnis="$5"
downloadarchive="$6"
 
if [ "$art" = "Serie" ]
then   
  staffel="$4"
  staffelset="$staffel"
  
  dat="$7"
  if [ $dat == '""' ]
  then
    datum=10010101
  else
    datum=${dat:7:4}${dat:4:2}${dat:1:2}
  fi
else
  set="$4"
  staffelset="$set"
  datum=10010101
   
  echo Verzeichnis "$verzeichnis"
  echo Set: "$set"
fi
 
#Folgende Funktonen werden am Programmende unten aufgerufen
#download
#verarbeiten
#verschiebenFilme


#
function download {

  mkdir -p Downloadarchiv
  mkdir -p Downloads
  cd Downloads  

  loesch="u"
  for i in *; 
  do 
    if [ "$i" = "*" ]
    then
      echo 'Download verzeichnis war schon leer'
    else  
      if [ "$loesch" == "u" ]
      then
	  loesch=$(zenity --entry --text "Im Temp-Downloadverzeichnis sind bereits Folgen vorhanden: Sollen diese verschoben werden (j/n)" --title "Löschung Temp-Downloadverzeichnis?")
          if [ "$loesch" == "j" ]
          then
             mkdir -p ../DownloadsAlt
          fi   
	  
      fi
     
      if [ "$loesch" == "j" ]
      then
	  mv "$i" "../DownloadsAlt/$i"
      fi
    fi
  done  
  
  download-playlist
}

function download-playlist {
  kein="ja"
  
  if [ "$downloadarchive" == "TRUE" ]
  then
    downarchdat="../Downloadarchiv/"$name"-"$staffelset""
    echo "youtube-dl --write-description --dateafter "$datum" --download-archive "$downarchdat"     -f bestvideo[ext=mp4]+bestaudio[ext=m4a] $link"
    youtube-dl --write-description --dateafter $datum  --download-archive "$downarchdat" --write-info-json        -f bestvideo[ext=mp4]+bestaudio[ext=m4a] "$link"
  else
    echo "youtube-dl --write-description --dateafter "$datum" -f bestvideo[ext=mp4]+bestaudio[ext=m4a] $link"
    youtube-dl --write-description --dateafter $datum   --write-info-json    -f bestvideo[ext=mp4]+bestaudio[ext=m4a] "$link"
  fi

  anzahl2=0
  anzahl=0

  # Zählen der runtergeladenen Filme
  for i in *.mp4; 
  do 
    if [ "$i" = "*.mp4" ]
    then
      echo 'Download verzeichnis war schon leer'
    else  
      anzahl=$(bc -l <<< $anzahl+1)	
    fi
   
  done

}



function verarbeiten {

  for i in *.mp4 
  do 
    echo "Aktuelle Datei $i"  
    if [ "$i" = "*.mp4" ]
    then
      echo "Kein Film"
    else
      kein="nein"
      if [ "$art" = "Serie" ]
      then
         verarbeitenSerie
      else
         verarbeitenFilm 
      fi
    fi
  done

}

function verarbeitenSerie {
      
      st=S$staffel
      for j in "$verzeichnis"/"$st"*.mp4; 
      do 
        echo "$j"
        letzte="$j"
      done

      episode=$(zenity --entry --text "Serie: $name \nStaffel: $staffel \nFolge: $i \nLetzte Folge: $letzte" --title "Episode?")
      if [ "$episode" = "" ]
      then
         episode=$(zenity --entry --text "Wollen sie wirklich Abbrechen? (j, oder Episondenr eingeben)" --title "Episode?")
         if [ "$episode" = "j" ]
         then
            exit
         fi   
            
      fi

      ep="E$episode"
     
      i2="${i:0: -4}"
      neu="$st$ep - ${i:0: -4}"
      text2="${i:0: -16}"
      text=$(echo "$text2" | sed -e 's/&/und/g')

       
      neu2=$(echo "$neu" | tr -d -c "[:alpha:][:blank:][:digit:]-,_."äöüÄÖÜß)
       
      mv "$i" "$neu2.mp4"
      
      erstellenNFOSerie

             


}

function verarbeitenFilm {
      echo "Film"
      
      anzahl2=$(bc -l <<< $anzahl2+1)
      
      i2="${i:0: -4}"
 
     
      erstellenNFOFilm
   
}


function erstellenNFOSerie {
       if [ -e "$i2.info.json" ] 
       then
         datum=$(jq '.upload_date' "$i2.info.json")
         if [ $datum == "null" ]
         then
            datum1=$(stat -c %x "$i")
            datum2=${datum1:0:10}
            jahr=${datum1:0:4}
            echo "Kein uploaddatum"
         else
             jahr="${datum:1:4}"
             datum2="${datum:1:4}"-"${datum:5:2}"-"${datum:7:2}"
         fi
      else
         datum1=$(stat -c %x "$i")
         datum2=${datum1:0:10}
         jahr=${datum1:0:4}
      fi

      if [ -e "$i2.info.json" ] 
      then  
         a=$(jq '.thumbnail' "$i2.info.json")
         if [ $a == "null" ]
         then
            echo "Kein Bild"
         else
            b=${a:1: -1}
            echo "$b"
            curl "$b" -o "$neu2-thumb.jpg"
        fi
      fi
    
  
      tr / " " < "$i2.description" > "Des.description"
      
      plot=$(echo $(cat "Des.description"))
     
      echo "<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>" > "$neu2.nfo"
      echo "<episodedetails>" >> "$neu2.nfo"
      echo "    <title>$text</title>"  >> "$neu2.nfo"
      echo "    <showtitle>$name</showtitle>"  >> "$neu2.nfo"
      echo "    <season>$staffel</season>"  >> "$neu2.nfo"
      echo "    <episode>$episode</episode>"  >> "$neu2.nfo"
      echo "    <plot>$plot</plot>"  >> "$neu2.nfo"
      echo "    <year>$jahr</year>"  >> "$neu2.nfo"
      echo "    <aired>$datum2</aired>"  >> "$neu2.nfo"
      echo "    <premiered>$datum2</premiered>"  >> "$neu2.nfo"
      echo "    <studio>Youtube</studio>"  >> "$neu2.nfo"
      echo "    <uniqueid></uniqueid>" >> "$neu2.nfo"
      echo " </episodedetails>"  >> "$neu2.nfo"

      verzeichnis2="$verzeichnis"
}

function erstellenNFOFilm {
    if [ -e "$i2.info.json" ] 
    then
       datum=$(jq '.upload_date' "$i2.info.json")
       if [ $datum == "null" ]
       then
          datum1=$(stat -c %x "$i")
          datum2=${datum1:0:10}
          jahr=${datum1:0:4}
          echo "Kein uploaddatum"
       else
           jahr="${datum:1:4}"
           datum2="${datum:1:4}"-"${datum:5:2}"-"${datum:7:2}"
       fi
    else
       datum1=$(stat -c %x "$i")
       datum2=${datum1:0:10}
       jahr=${datum1:0:4}
    fi
    
    
    if [ $anzahl -eq 1 ]
    then
       echo "keine Playlist"
       teil2=""
    else
       teil=$(zenity --entry --text "Name: $i " --title "Filmteil")
       teil2=" Disc$teil"
    fi

    mv "$i" "$name$teil2.mp4"
    n=$name

    tr / " " < "$i2.description" > "Des.description"
    plot[$anzahl2]="$(echo $(cat "Des.description"))"
         
    if [ $anzahl2 -eq $anzahl ]
    then
       plot2="${plot[*]}"

       echo "Plot2: $plot2"
       echo "<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>" > "$name.nfo"
       echo "<movie>"  >> "$name.nfo"
       echo "    <title>$name</title>"  >> "$name.nfo"
       echo "    <year>$jahr</year>"  >> "$name.nfo"
       echo "    <plot>$plot2</plot>"  >> "$name.nfo"
       echo "    <set>$set</set>"  >> "$name.nfo"
       echo "    <premiered>$datum2</premiered>"  >> "$name.nfo"
       echo "    <aired>$datum2</aired>"  >> "$name.nfo"
       echo "</movie>"  >> "$name.nfo"

       verzeichnis2="$verzeichnis"/"$name"

       mkdir -p "$verzeichnis2"
       
       if [ -e "$i2.info.json" ] 
       then
      
          a=$(jq '.thumbnail' "$i2.info.json")
          if [ $a == "null" ]
          then
             echo "Kein Bild"
          else
             b=${a:1: -1}
             echo "$b"
             curl "$b" -o "$name-fanart.jpg"
          fi 
       fi
    fi
}

function verschiebenFilme {

  #Die nicht mehr benötigten Dateien werden gelöscht
  if [ "$kein" = "nein" ]
  then
    echo "Filme gefunden"
    rm *.description
    rm *.info.json
  fi

  #Dateien in das gewünschte Verzeichnis verschieben
  for i in *; 
  do 
    echo "Aktuelle Datei $i"
    if [ "$i" = "*" ]
    then
      echo 'keine Dateien zum verschieben'
    else  
      mv "$i" "$verzeichnis2/$i"
    fi
  done

}


download
verarbeiten
verschiebenFilme
