#! /bin/bash

#Ersteller: Michael Spahr
#Datum der letzen Änderung: 03.07.2017
#Version: 1.0
#Dieses Programm darf jeder verändern und erweitern. Ich bitte Euch mir dann die Änderungen zu schicken, so daß ich diese in den offziellen Teil einbaun kann
#Viel Spaß beim Laden der Youtube-Filme




#Dies Funktion wird am Anfang einmal aufgerufen. 
#Es wird dort Das Formular angezeigt und die Eingaben verarbeitet. 
#Dies geschieht bis Beenden ausgewählt wird.
function formular {
text="anfang"

 while read line 
 do 
    if [ "$line" == "[sets]" ]
    then
      confset="TRUE"
      confdatei="FALSE"
    elif [ "$line" == "[scriptdatei]" ]
    then
      confdatei="TRUE"
      confset="FALSE"
    elif [ "${line:0:1}" == "[" ]
    then
      confdatei="FALSE"
      confset="FALSE"
     else
      if [ "$confset" == "TRUE" ]
      then
        
         sets=$sets$line
      elif [ "$confdatei" == "TRUE" ]  
      then
         stdDatei="$line"
      fi
    fi
 done < config.conf


until [ "$text" == "" ]
do
   confset="FALSE"
   confdatei="FALSE"
   

   
   res=($(yad \
   --title="Download Youtube-Filme / Playlists und erstellen NFO-Datei für Kodi" \
   --window-icon=gtk-about \
   --geometry=400x500 \
   --form \
   --item-separator=, \
   --separator="#" \
   --field="Serie:CHK" \
   --field="Youtube Link:CBE"  \
   --field="Name:CBE" " " \
   --field="Staffel:NUM"  \
   --field="Staffelverzeichnis:DIR" " " \
   --field="Download ab Datum:DT" \
   --field="Film:CHK"  \
   --field="Youtube Link:CBE" \
   --field="Name:CBE"  \
   --field="Filmverzeichnis:DIR" " " \
   --field="Set:CB" " " \
   --field="Script-Datei mit den Links:CHK"  \
   --field="Download-Datei:SFL" " " \
   --field="Eingabe speichern:CHK"  \
   --field="Download-Datei:SFL" " " \
   --button="Download" \
   --button="Beenden" "" "" "" "" "$sets" "" "$stdDatei" "" "$stdDatei"   ))
   
   
   text="${res[*]}"
   echo "Text: $text"
   verarbeiten
done

echo "Filme/Serien vollständig geladen - Terminal kann geschlossen werden"
echo "Filme/Serien vollständig geladen - Terminal kann geschlossen werden"
echo "Filme/Serien vollständig geladen - Terminal kann geschlossen werden"
echo "Filme/Serien vollständig geladen - Terminal kann geschlossen werden"
}

# Hier wird entschieden, ob ein Film eine Serie, oder eine Scipt-Datei verarbeitet werden soll
function verarbeiten {

aufteilen
script2=$script

echo "Scriptdatei: $scriptdatei"
if [ "$scriptdatei" == "" ]
then
  scriptdatei="playlists.list"
fi

if  [ "$script" == "TRUE" ]
then
   echo "Datei: $downdat"
   speichern="TRUE" 
   
   while read line
   do 

     text="$line"
     aufteilen
     if  [ "$serie" == "TRUE" ]
     then
  
        serie 
     fi  

     if  [ "$film" == "TRUE" ]
     then
        film
     fi  
   done   <  "$downdat"
elif  [ "$serie" == "TRUE" ]
then
  if  [ "$speichern" == "TRUE" ]
  then
     echo "Scriptdatei: $scriptdatei"

     echo "${res[*]}" >> "$scriptdatei"
  else
     echo "${res[*]}" 
  fi
  serie
elif  [ "$film" == "TRUE" ]
then
  if  [ "$speichern" == "TRUE" ]
  then
     echo "${res[*]}" >> "$scriptdatei"
  else
     echo "${res[*]}" 
  fi

  film
     
fi  

}

# Die Eingaben aus dem Formular wird in die Felder aufgeteilt
function aufteilen {

echo "Funkion aufteilen"
b=$(echo $text | cut -d '#' -f 1)
serie="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 2)
serlink="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 3)
sername="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 4)
sersta="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 5)
server="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 6)
serdate="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 7)
film="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 8)
filmlink="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 9)
filmname="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 10)
filmver="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 11)
set="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 12)
script="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 13)
downdat="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 14)
speichern="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"

b=$(echo $text | cut -d '#' -f 15)
scriptdatei="$(echo -e "${b}" | sed -e 's/^[[:space:]]*//')"





echo "Script: $script"
echo "$downdat"
echo "serie:  $serie"
echo "$serlink"
echo "$sername"
echo "$sersta"
echo "$server"
echo "$serdate"
echo "Fillm: $film"
echo "$filmlink"
echo "$filmname"
echo "$filmver"
echo "Script: $speichern"
echo "$scriptdatei"


}


#Aufruf Download-Script für den Download einer Serie
function serie {
 a="${sersta}"
  b="0${sersta}"
  if [ "${a:1:1}" == "," ] 
  then
     b="0${a:0:-7}"
  fi

  if [ "${a:2:1}" == "," ] 
  then
     b="0${a:0:-7}"
  fi
  
 
 staffel="${b:(-2):9}"

  a=$serlink
  b=$sername 
  c=$staffel 
  d=$server

  f='"'$serdate'"'
  
  echo $speichern
  if [ "$speichern" == "TRUE" ] || [ "$script2" == "TRUE" ]
  then
     downloadarchiv="TRUE"
  else
     downloadarchiv="FALSE"
  fi 
  e=$downloadarchiv  
./Laden.sh "Serie" "$a" "$b" $c "$d" "$e" "$f"
}

#Aufruf Download-Script für den Download eines Film
function film {
  a=$filmlink
  b=$filmname 
  c=$set 
  d=$filmver
  downloadarchiv=" "
   ./Laden.sh "Film" "$a" "$b" "$c" "$d" 
 
}


#Aufruf der ersten Funkton "Formular"
formular